# dpdk-jitter-rss

Modifica di cs/util/test-jitter-dpdk per provare con RSS (Receive Side Scaling)

## command line

TODO
usata bavosa per le prove

## Results

### Problema distribuzione non uniforme IP

L'IP che termina con .21 viene sempre assegnato alla coda "sbagliata".
Vedi ![Distribuzione code](pictures/assegnazione_coda_IP.png)

Inoltre se salgo sopra i 31kHZ è sempre il .21 ad essere presente nella ricezione da 2 pacchetti

### Risultati 16 core

a 449 kHz solo il core 15, quello che riceve il IP .21 di troppo non ce la fa, con 16 code.
a 450 kHz cominciano a cedere anche gli altri

```
lcore_id:3  min_per:1us, max_per:60us, max_event_pkt=1, lost_pkt=325734, spur_pkt=0, rx_pkt=325735, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=3us max_free_time=1us perc_one_pkt=100.000%
lcore_id:7  min_per:0us, max_per:62us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=3us max_free_time=1us perc_one_pkt=100.000%
lcore_id:9  min_per:1us, max_per:61us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:13  min_per:10000000000us, max_per:0us, max_event_pkt=0, lost_pkt=0, spur_pkt=0, rx_pkt=0, rte_eth_rx_burst_max_time=0us max_loop_time=0us max_rx_packet_time=0us max_free_time=0us perc_one_pkt=-nan%
lcore_id:11  min_per:1us, max_per:63us, max_event_pkt=1, lost_pkt=325734, spur_pkt=0, rx_pkt=325735, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:15  min_per:0us, max_per:61us, max_event_pkt=3, lost_pkt=651473, spur_pkt=0, rx_pkt=651474, rte_eth_rx_burst_max_time=3us max_loop_time=6us max_rx_packet_time=4us max_free_time=3us perc_one_pkt=5.937%
lcore_id:25  min_per:1us, max_per:62us, max_event_pkt=1, lost_pkt=325736, spur_pkt=0, rx_pkt=325737, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:17  min_per:2us, max_per:61us, max_event_pkt=1, lost_pkt=325736, spur_pkt=0, rx_pkt=325737, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=5us max_free_time=1us perc_one_pkt=100.000%
lcore_id:5  min_per:1us, max_per:62us, max_event_pkt=1, lost_pkt=325734, spur_pkt=0, rx_pkt=325735, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=3us max_free_time=2us perc_one_pkt=100.000%
lcore_id:19  min_per:0us, max_per:63us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:1  min_per:2us, max_per:60us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=3us max_free_time=1us perc_one_pkt=100.000%
lcore_id:29  min_per:0us, max_per:64us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:27  min_per:1us, max_per:61us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:23  min_per:1us, max_per:63us, max_event_pkt=1, lost_pkt=325734, spur_pkt=0, rx_pkt=325735, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=4us max_free_time=1us perc_one_pkt=100.000%
lcore_id:21  min_per:1us, max_per:63us, max_event_pkt=1, lost_pkt=325737, spur_pkt=0, rx_pkt=325738, rte_eth_rx_burst_max_time=2us max_loop_time=6us max_rx_packet_time=4us max_free_time=2us perc_one_pkt=100.000%
lcore_id:31  min_per:0us, max_per:64us, max_event_pkt=1, lost_pkt=325735, spur_pkt=0, rx_pkt=325736, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=3us max_free_time=1us perc_one_pkt=100.000%
```

### Risultati 16 code su singolo core

16 code su singolo core a 428 kHz

```
lcore_id:1  min_per:0us, max_per:30us, max_event_pkt=1, lost_pkt=4972228, spur_pkt=0, rx_pkt=4972229, rte_eth_rx_burst_max_time=2us max_loop_time=5us max_rx_packet_time=1us max_free_time=1us perc_one_pkt=100.000%
```

